#ifndef _ATCG_H_
#define _ATCG_H_

#include <stdio.h>
#include "constants.h"
#include "functions.h"
#include <map>
#include <string>
#include <ctype.h>

using namespace std;

class CAtcg;
class CStats;

typedef map<string, CAtcg>CMAP;
typedef map<string, CStats>SMAP;

class CAtcg {
  double m_dA, m_dT, m_dC, m_dG;
public:
//--------------------------
  CAtcg();
//--------------------------
  CAtcg(double dA, double dT, double dC, double dG);
//--------------------------
  void assign(double dA, double dT, double dC, double dG);
//--------------------------
  CAtcg& operator = (CAtcg& atcg);
//--------------------------
  void print(FILE *OUTF);
//--------------------------
  double getA();
//--------------------------
  double getT();
//--------------------------
  double getC();
//--------------------------
  double getG();
//--------------------------
  double getAT();
//--------------------------
  double getCG();
};
//==================================
class CStats {
  unsigned long m_iLength;
  unsigned long m_iTotal;
  unsigned long m_iA, m_iT, m_iC, m_iG;
public:
//--------------------------
  CStats();
//--------------------------
  void assign(unsigned long iLength, unsigned long iTotal, unsigned long iA, unsigned long iT, unsigned long iC, unsigned long iG);
//--------------------------
  void add(char *p_cLine);
//--------------------------
  void reset();
//--------------------------
  void add(char cResidue);
//--------------------------
  CStats& operator += (const CStats& stat);
//--------------------------
  CStats& operator = (const CStats& stat);
//--------------------------
  CStats& operator + (const CStats& stat);
//--------------------------
  unsigned long getACount() const;
//--------------------------
  unsigned long getTCount() const;
//--------------------------
  unsigned long getCCount() const;
//--------------------------
  unsigned long getGCount() const;
//--------------------------
  double getARate() const;
//--------------------------
  double getTRate() const;
//--------------------------
  double getCRate() const;
//--------------------------
  double getGRate() const;
//--------------------------
  unsigned long getLength() const;
//--------------------------
  unsigned long getTotal() const;
};
//=======================================
void printMap(FILE *OUTF, CMAP &cmap);
//=======================================
CAtcg& countATCG(FILE *INF, CMAP &cmap);
//=======================================
CAtcg& countATCG(const SMAP &smap, CMAP &cmap);
//=======================================
CStats& countStat(FILE *INF, SMAP &smap);
//=======================================
void getStat(FILE *INF, SMAP &smap);
#endif //_ATCG_H_
