/***************************************************************************
                          chspinfo.cpp  -  description
                             -------------------
    begin                : Fri Nov 22 2002
    copyright            : (C) 2002 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "chspinfo.h"

CHSPInfo::CHSPInfo()
{
    reset();
}
CHSPInfo::~CHSPInfo()
{}
/** set m_dPrb */
void CHSPInfo::setPrb(const double& dPrb)
{
    m_dPrb = dPrb;
}
/** set m_dExp */
void CHSPInfo::setExp(const double& dExp)
{
    m_dExp = dExp;
}
/** set m_iScr */
void CHSPInfo::setScr(const int& iScore)
{
    m_iScr = iScore;
}
/** set m_nIdnt */
void CHSPInfo::setIdt(const double& dIdt)
{
    m_dIdt = dIdt;
}
/** set m_nLen */
void CHSPInfo::setLen(const unsigned int& iLen)
{
    m_nLen = iLen;
}
/** set m_nPos */
void CHSPInfo::setPos(const double& dPos)
{
    m_dPos = dPos;
}
const unsigned int CHSPInfo::getDbLen() const
{
    return m_ndbLen;
}
const unsigned int CHSPInfo::getQuLen() const
{
    return m_nquLen;
}
void CHSPInfo::setDbLen(unsigned int idblen)
{
    m_ndbLen = idblen;
}
void CHSPInfo::setQuLen(unsigned int iqulen)
{
    m_nquLen = iqulen;
}
/** No descriptions */
void CHSPInfo::print(ostream &os) const
{
    os << "SCR= " << m_iScr << " IDT= " << m_dIdt << " POS= " << m_dPos << "\n";
}
/** No descriptions */
ostream& operator << (ostream& os, CHSPInfo &info)
{
    info.print(os);
    return os;
}
/** No descriptions */
void CHSPInfo::reset()
{
    m_iScr = 0;
    m_dExp = 0;
    m_nLen = 0;
    m_dPrb = 0;
    m_dIdt = 0;
    m_dPos = 0;
}
