/***************************************************************************
                          cseqstat.h  -  description
                             -------------------
    begin                : Fri Dec 6 2002
    copyright            : (C) 2002 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CSEQSTAT_H
#define CSEQSTAT_H

#include <string>
#include <stdio.h>
#include <stdexcept>

#include "BioSequence.h"
/*
#define BASERANGE 128

enum SEQTYPE { NA, AA, NONE };
*/
/**
  *@author Oleksiy Kohany
  */

using namespace std;
  
class CSeqStat {
public: 
/**------------------------------------------------------------------*/
	CSeqStat();
/**------------------------------------------------------------------*/
	CSeqStat(string& sName);
/**------------------------------------------------------------------*/
	virtual ~CSeqStat();
  /** Write property of string Name. */
  virtual void setName( const string& _newVal);
  /** Read property of string Name. */
  virtual const string& getName() const;
  /** No descriptions */
  void addData(const string& sLine);
  /** No descriptions */
  void addData(const char* pcLine);
  /** No descriptions */
  void reset();
  /** No descriptions */
  SEQTYPE guessType() const;
  /** No descriptions */
  virtual void print(ostream* os) const;
  /** No descriptions */
  virtual void print(FILE* os) const;
  /** No descriptions */
  static const char* typeName(SEQTYPE type);
  /** Reads and analyses next sequences from db file. */
  int read(istream& is);
  /** No descriptions */
  CSeqStat& operator += (const CSeqStat& sst);
  /** No descriptions */
  const unsigned long* getStat() const;
  /** No descriptions */
  unsigned long getLength() const;
private: // Private attributes
  /**  */
  unsigned long Stat[BASERANGE];
  /**  */
  string Name;
  /**  */
  unsigned long Size;
public: // Public attributes
  /**  */
  static bool sbWithN;
};

ostream& operator << (ostream& os, const CSeqStat& stat);

#endif
